<template>
  <div>
    <gmap-map
      :center="getCenter"
      :zoom="mapZoom"
      :options="mapOptions"
      :style="mapStyle"
      ref="mapRef"
    >
      <gmap-marker
        v-if="hasCurrentDiveCoordinates"
        :key="getDiveMarkerId"
        :position="getPosition"
      ></gmap-marker>
    </gmap-map>
  </div>
</template>
<script>
export default {
  name: "GoogleMap",
  data: function () {
    return {
      defaultCenter: { lat: 47.37088, lng: 8.5415 },
      mapZoom: 8,
      mapOptions: { streetViewControl: false },
      mapStyle: { width: "100%", height: "100%" },
    };
  },
  computed: {
    currentDive() {
      return this.$store.state.currentDive;
    },
    getCenter() {
      if (this.currentDive != null) {
        const pos = this.currentDive.googleMapsCoordinates;
        if (pos != null) {
          return { lat: pos.lat, lng: pos.lng };
        }
      }
      return this.defaultCenter;
    },
    getDiveMarkerId() {
      if (this.hasCurrentDiveCoordinates) {
        return this.currentDive.id;
      }
      return "";
    },
    getPosition() {
      if (this.hasCurrentDiveCoordinates) {
        return this.currentDive.googleMapsCoordinates;
      }
      return "";
    },
    hasCurrentDiveCoordinates() {
      if (
        this.currentDive != null &&
        this.currentDive.googleMapsCoordinates != null
      ) {
        return true;
      }
      return false;
    },
  },
};
</script>
